diff --git a/sysdeps/unix/sysv/linux/arm/posix_fadvise.c b/sysdeps/unix/sysv/linux/arm/posix_fadvise.c
deleted file mode 100644
index fafcde59..0000000
--- a/sysdeps/unix/sysv/linux/arm/posix_fadvise.c
+++ /dev/null
@@ -1,30 +0,0 @@
-/* Copyright (C) 2005-2017 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <fcntl.h>
-
-int __posix_fadvise64_l64 (int fd, off64_t offset, off64_t len, int advise);
-
-/* Advice the system about the expected behaviour of the application with
-   respect to the file associated with FD.  */
-
-int
-posix_fadvise (int fd, off_t offset, off_t len, int advise)
-{
-  /* ARM only has a syscall for fadvise64_64.  */
-  return __posix_fadvise64_l64 (fd, offset, len, advise);
-}
diff --git a/sysdeps/unix/sysv/linux/mips/kernel-features.h b/sysdeps/unix/sysv/linux/mips/kernel-features.h
index 83a5c8f..7db5338 100644
--- a/sysdeps/unix/sysv/linux/mips/kernel-features.h
+++ b/sysdeps/unix/sysv/linux/mips/kernel-features.h
@@ -34,6 +34,9 @@
 # define __ASSUME_ALIGNED_REGISTER_PAIRS	1
 /* mips32 only supports ipc syscall.  */
 # undef __ASSUME_DIRECT_SYSVIPC_SYSCALLS
+
+/* The o32 MIPS fadvise64 syscall behaves as fadvise64_64.  */
+# define __ASSUME_FADVISE64_AS_64_64		1
 #endif
 
 /* Define that mips64-n32 is a ILP32 ABI to set the correct interface to
diff --git a/sysdeps/unix/sysv/linux/mips/mips32/posix_fadvise.c b/sysdeps/unix/sysv/linux/mips/mips32/posix_fadvise.c
deleted file mode 100644
index 6e9c3f9..0000000
--- a/sysdeps/unix/sysv/linux/mips/mips32/posix_fadvise.c
+++ /dev/null
@@ -1,4 +0,0 @@
-/* The o32 MIPS fadvise64 syscall behaves as fadvise64_64.  The ARM
-   implementation of posix_fadvise works correctly for this case; the
-   generic implementation mishandles it.  */
-#include <sysdeps/unix/sysv/linux/arm/posix_fadvise.c>
diff --git a/sysdeps/unix/sysv/linux/posix_fadvise.c b/sysdeps/unix/sysv/linux/posix_fadvise.c
index 15d72d4..222ac97 100644
--- a/sysdeps/unix/sysv/linux/posix_fadvise.c
+++ b/sysdeps/unix/sysv/linux/posix_fadvise.c
@@ -24,12 +24,16 @@
 
 #ifndef __OFF_T_MATCHES_OFF64_T
 
-/* Both arm and powerpc implements fadvise64_64 with last 'advise' argument
-   just after 'fd' to avoid the requirement of implementing 7-arg syscalls.
-   ARM also defines __NR_fadvise64_64 as __NR_arm_fadvise64_64.
+/* Default implementation will use __NR_fadvise64 with expected argument
+   positions (for instance i386 and powerpc32 that uses __ALIGNMENT_ARG).
 
-   tile requires __ASSUME_ALIGNED_REGISTER_PAIRS but implements the 32-bit
-   fadvise64_64 without the padding 0 after fd.
+   Second option will be used by arm which define __NR_arm_fadvise64_64
+   (redefined to __NR_fadvise64_64 in kernel-features.h) that behaves as
+   __NR_fadvise64_64 (without the aligment argument required for the ABI).
+
+   Third option will be used by both tile 32-bits and mips o32.  Tile
+   will set __ASSUME_FADVISE64_64_NO_ALIGN to issue a 6 argument syscall,
+   while mips will use a 7 argument one with __NR_fadvise64.
 
    s390 implements fadvice64_64 using a specific struct with arguments
    packed inside.  This is the only implementation handled in arch-specific
@@ -39,15 +43,14 @@ int
 posix_fadvise (int fd, off_t offset, off_t len, int advise)
 {
   INTERNAL_SYSCALL_DECL (err);
-# ifdef __NR_fadvise64
+# if defined (__NR_fadvise64) && !defined (__ASSUME_FADVISE64_AS_64_64)
   int ret = INTERNAL_SYSCALL_CALL (fadvise64, err, fd,
 				   __ALIGNMENT_ARG SYSCALL_LL (offset),
 				   len, advise);
 # else
 #  ifdef __ASSUME_FADVISE64_64_6ARG
   int ret = INTERNAL_SYSCALL_CALL (fadvise64_64, err, fd, advise,
-				   __ALIGNMENT_ARG SYSCALL_LL (offset),
-				   SYSCALL_LL (len));
+				   SYSCALL_LL (offset), SYSCALL_LL (len));
 #  else
 
 #   ifdef __ASSUME_FADVISE64_64_NO_ALIGN
@@ -55,6 +58,10 @@ posix_fadvise (int fd, off_t offset, off_t len, int advise)
 #    define __ALIGNMENT_ARG
 #   endif
 
+#   ifndef __NR_fadvise64_64
+#    define __NR_fadvise64_64 __NR_fadvise64
+#   endif
+
   int ret = INTERNAL_SYSCALL_CALL (fadvise64_64, err, fd,
 				   __ALIGNMENT_ARG SYSCALL_LL (offset),
 				   SYSCALL_LL (len), advise);