diff --git a/sysdeps/unix/sysv/linux/openat.c b/sysdeps/unix/sysv/linux/openat.c
index 2c620d8..1587305 100644
--- a/sysdeps/unix/sysv/linux/openat.c
+++ b/sysdeps/unix/sysv/linux/openat.c
@@ -15,31 +15,18 @@
    License along with the GNU C Library; if not, see
    <http://www.gnu.org/licenses/>.  */
 
-#include <errno.h>
 #include <fcntl.h>
 #include <stdarg.h>
-#include <stddef.h>
-#include <stdio.h>
-#include <string.h>
-#include <sys/stat.h>
-#include <sysdep-cancel.h>
-#include <not-cancel.h>
-
 
-#ifndef OPENAT
-# define OPENAT openat
-#endif
-
-#define UNDERIZE(name) UNDERIZE_1 (name)
-#define UNDERIZE_1(name) __##name
-#define __OPENAT UNDERIZE (OPENAT)
+#include <sysdep-cancel.h>
 
+#ifndef __OFF_T_MATCHES_OFF64_T
 
 /* Open FILE with access OFLAG.  Interpret relative paths relative to
    the directory associated with FD.  If OFLAG includes O_CREAT or
    O_TMPFILE, a fourth argument is the file protection.  */
 int
-__OPENAT (int fd, const char *file, int oflag, ...)
+__libc_openat (int fd, const char *file, int oflag, ...)
 {
   mode_t mode = 0;
   if (__OPEN_NEEDS_MODE (oflag))
@@ -50,12 +37,10 @@ __OPENAT (int fd, const char *file, int oflag, ...)
       va_end (arg);
     }
 
-  /* We have to add the O_LARGEFILE flag for openat64.  */
-#ifdef MORE_OFLAGS
-  oflag |= MORE_OFLAGS;
-#endif
-
   return SYSCALL_CANCEL (openat, fd, file, oflag, mode);
 }
-libc_hidden_def (__OPENAT)
-weak_alias (__OPENAT, OPENAT)
+weak_alias (__libc_openat, __openat)
+libc_hidden_weak (__openat)
+weak_alias (__libc_openat, openat)
+
+#endif
diff --git a/sysdeps/unix/sysv/linux/openat64.c b/sysdeps/unix/sysv/linux/openat64.c
index 9e7a2b3..4942061 100644
--- a/sysdeps/unix/sysv/linux/openat64.c
+++ b/sysdeps/unix/sysv/linux/openat64.c
@@ -1,4 +1,55 @@
-#define OPENAT openat64
-#define MORE_OFLAGS O_LARGEFILE
+/* Copyright (C) 2007-2017 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
 
-#include "openat.c"
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include <fcntl.h>
+#include <stdarg.h>
+
+#include <sysdep-cancel.h>
+
+/* Open FILE with access OFLAG.  Interpret relative paths relative to
+   the directory associated with FD.  If OFLAG includes O_CREAT or
+   O_TMPFILE, a fourth argument is the file protection.  */
+int
+__libc_openat64 (int fd, const char *file, int oflag, ...)
+{
+  mode_t mode = 0;
+  if (__OPEN_NEEDS_MODE (oflag))
+    {
+      va_list arg;
+      va_start (arg, oflag);
+      mode = va_arg (arg, mode_t);
+      va_end (arg);
+    }
+
+#ifdef __OFF_T_MATCHES_OFF64_T
+# define EXTRA_OPEN_FLAGS 0
+#else
+# define EXTRA_OPEN_FLAGS O_LARGEFILE
+#endif
+
+  return SYSCALL_CANCEL (openat, fd, file, oflag | EXTRA_OPEN_FLAGS, mode);
+}
+
+strong_alias (__libc_openat64, __openat64)
+libc_hidden_weak (__openat64)
+weak_alias (__libc_openat64, openat64)
+
+#ifdef __OFF_T_MATCHES_OFF64_T
+strong_alias (__libc_openat64, __openat)
+libc_hidden_weak (__openat)
+weak_alias (__libc_openat64, openat)
+#endif
diff --git a/sysdeps/unix/sysv/linux/wordsize-64/openat.c b/sysdeps/unix/sysv/linux/wordsize-64/openat.c
deleted file mode 100644
index be31a35..0000000
--- a/sysdeps/unix/sysv/linux/wordsize-64/openat.c
+++ /dev/null
@@ -1,11 +0,0 @@
-#define __openat64 __rename___openat64
-#define openat64 __rename_openat64
-
-#include "../openat.c"
-
-#undef __openat64
-#undef openat64
-
-strong_alias (__openat, __openat64)
-hidden_ver (__openat, __openat64)
-weak_alias (openat, openat64)
diff --git a/sysdeps/unix/sysv/linux/wordsize-64/openat64.c b/sysdeps/unix/sysv/linux/wordsize-64/openat64.c
deleted file mode 100644
index b4a864b..0000000
--- a/sysdeps/unix/sysv/linux/wordsize-64/openat64.c
+++ /dev/null
@@ -1 +0,0 @@
-/* Defined in openat.c.  */